#include <math.h>
#include <iostream.h>  
#include <fstream.h>
#include "comprow_double.h"
#include "iohb_double.h"                 // Harwell-Boeing matrix I/O header
#include "mvblasd.h"                     // MV_Vector level 1 BLAS
#include "diagpre_double.h"              // Diagonal preconditioner
#include "ilupre_double.h"
#include MATRIX_H
#include "gmres.h"

extern "C" {
int gmres_solve(int size, int nb_non_zero, double *val, int *colptr, int *rowind, double* b, double *r) {
	int i;
	int result;
	VECTOR_double B(size, 0.),R(size, 0.);
		CompCol_Mat_double A(size,size,nb_non_zero,val,rowind,colptr);


		for(i=0;i<size;i++) {
			B[i]=b[i];    //-2 because array ranges from 2 to 2*N+2
			R[i]=r[i];
		}
		int maxit=500;
		double tol=0.01;

		//		cout<<A<<endl<<B<<endl<<R<<endl;

		//exit(0);
		int restart = 50;
		MATRIX_double H(restart+1, restart, 0.0);

		CompCol_ILUPreconditioner_double D(A);
		result = GMRES(A, R, B, D, H, restart, maxit, tol);
		for(i=0;i<size;i++) {
			r[i]=R[i];
		}

		return result;
}
}
